2 # Tool mainly for U-Boot Quality Assurance: build one or more board
3 # configurations with minimal verbosity, showing only warnings and
8 # if exiting with 0, write to stdout, else write to stderr
10 [ "${ret}" -eq 1 ] && exec 1>&2
12 Usage: MAKEALL [options] [--] [boards-to-build]
15 -a ARCH, --arch ARCH Build all boards with arch ARCH
16 -c CPU, --cpu CPU Build all boards with cpu CPU
17 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
18 -s SOC, --soc SOC Build all boards with soc SOC
19 -h, --help This help output
21 Selections by these options are logically ANDed; if the same option
22 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
23 will select all configurations where the vendor is either FOO or
24 BAR. Any additional arguments specified on the command line are
25 always build additionally. See the boards.cfg file for more info.
27 If no boards are specified, then the default is "powerpc".
29 Environment variables:
30 BUILD_NCPUS number of parallel make jobs (default: auto)
31 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
32 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
33 BUILD_DIR output build directory (default: ./)
36 - build all Power Architecture boards:
38 MAKEALL --arch powerpc
40 - build all PowerPC boards manufactured by vendor "esd":
41 MAKEALL -a powerpc -v esd
42 - build all PowerPC boards manufactured either by "keymile" or "siemens":
43 MAKEALL -a powerpc -v keymile -v siemens
44 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
45 MAKEALL -c mpc83xx -v freescale 4xx
50 SHORT_OPTS="ha:c:v:s:"
51 LONG_OPTS="help,arch:,cpu:,vendor:,soc:"
53 # Option processing based on util-linux-2.13/getopt-parse.bash
55 # Note that we use `"$@"' to let each command-line parameter expand to a
56 # separate word. The quotes around `$@' are essential!
57 # We need TEMP as the `eval set --' would nuke the return value of
59 TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
62 [ $? != 0 ] && usage 1
64 # Note the quotes around `$TEMP': they are essential!
72 # echo "Option ARCH: argument \`$2'"
73 if [ "$opt_a" ] ; then
74 opt_a="${opt_a%)} || \$2 == \"$2\")"
76 opt_a="(\$2 == \"$2\")"
81 # echo "Option CPU: argument \`$2'"
82 if [ "$opt_c" ] ; then
83 opt_c="${opt_c%)} || \$3 == \"$2\")"
85 opt_c="(\$3 == \"$2\")"
90 # echo "Option SoC: argument \`$2'"
91 if [ "$opt_s" ] ; then
92 opt_s="${opt_s%)} || \$6 == \"$2\")"
94 opt_s="(\$6 == \"$2\")"
99 # echo "Option VENDOR: argument \`$2'"
100 if [ "$opt_v" ] ; then
101 opt_v="${opt_v%)} || \$5 == \"$2\")"
103 opt_v="(\$5 == \"$2\")"
112 echo "Internal error!" >&2 ; exit 1 ;;
115 # echo "Remaining arguments:"
116 # for arg do echo '--> '"\`$arg'" ; done
119 [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
120 [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
121 [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
122 [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
124 if [ "$SELECTED" ] ; then
125 SELECTED=$(awk '('"$FILTER"') { print $1 }' boards.cfg)
127 # Make sure some boards from boards.cfg are actually found
128 if [ -z "$SELECTED" ] ; then
129 echo "Error: No boards selected, invalid arguments"
134 #########################################################################
136 # Print statistics when we exit
140 # Determine number of CPU cores if no default was set
141 : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
143 if [ "$BUILD_NCPUS" -gt 1 ]
145 JOBS="-j $((BUILD_NCPUS + 1))"
151 if [ "${CROSS_COMPILE}" ] ; then
152 MAKE="make CROSS_COMPILE=${CROSS_COMPILE}"
157 if [ "${MAKEALL_LOGDIR}" ] ; then
158 LOG_DIR=${MAKEALL_LOGDIR}
163 if [ ! "${BUILD_DIR}" ] ; then
167 [ -d ${LOG_DIR} ] || mkdir ${LOG_DIR} || exit 1
171 # Keep track of the number of builds and errors
177 # Helper funcs for parsing boards.cfg
183 '($1 !~ /^#/ && $field == select) { print $1 }' \
186 boards_by_arch() { boards_by_field 2 "$@" ; }
187 boards_by_cpu() { boards_by_field 3 "$@" ; }
188 boards_by_soc() { boards_by_field 6 "$@" ; }
190 #########################################################################
192 #########################################################################
194 LIST_5xx="$(boards_by_cpu mpc5xx)"
196 #########################################################################
198 #########################################################################
200 LIST_5xxx="$(boards_by_cpu mpc5xxx)"
202 #########################################################################
204 #########################################################################
206 LIST_512x="$(boards_by_cpu mpc512x)"
208 #########################################################################
210 #########################################################################
212 LIST_8xx="$(boards_by_cpu mpc8xx)"
214 #########################################################################
216 #########################################################################
218 LIST_4xx="$(boards_by_cpu ppc4xx)"
220 #########################################################################
222 #########################################################################
224 LIST_8220="$(boards_by_cpu mpc8220)"
226 #########################################################################
228 #########################################################################
230 LIST_824x="$(boards_by_cpu mpc824x)"
232 #########################################################################
233 ## MPC8260 Systems (includes 8250, 8255 etc.)
234 #########################################################################
236 LIST_8260="$(boards_by_cpu mpc8260)"
238 #########################################################################
239 ## MPC83xx Systems (includes 8349, etc.)
240 #########################################################################
242 LIST_83xx="$(boards_by_cpu mpc83xx)"
244 #########################################################################
245 ## MPC85xx Systems (includes 8540, 8560 etc.)
246 #########################################################################
248 LIST_85xx="$(boards_by_cpu mpc85xx)"
250 #########################################################################
252 #########################################################################
254 LIST_86xx="$(boards_by_cpu mpc86xx)"
256 #########################################################################
258 #########################################################################
260 LIST_74xx_7xx="$(boards_by_cpu 74xx_7xx)"
262 #########################################################################
264 #########################################################################
287 # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
288 # still using "ppc" instead of "powerpc"
293 #########################################################################
295 #########################################################################
297 LIST_SA="$(boards_by_cpu sa1100)"
299 #########################################################################
301 #########################################################################
303 LIST_ARM9="$(boards_by_cpu arm920t) \
304 $(boards_by_cpu arm926ejs) \
305 $(boards_by_cpu arm925t) \
311 #########################################################################
313 #########################################################################
314 LIST_ARM11="$(boards_by_cpu arm1136) \
323 #########################################################################
325 #########################################################################
327 LIST_ARMV7="$(boards_by_cpu armv7)"
329 #########################################################################
331 #########################################################################
333 LIST_at91="$(boards_by_soc at91)"
335 #########################################################################
337 #########################################################################
339 LIST_pxa="$(boards_by_cpu pxa)"
341 LIST_ixp="$(boards_by_cpu ixp)
346 #########################################################################
348 #########################################################################
361 #########################################################################
362 ## MIPS Systems (default = big endian)
363 #########################################################################
370 vct_platinum_onenand \
371 vct_platinum_onenand_small \
373 vct_platinumavc_small \
374 vct_platinumavc_onenand \
375 vct_platinumavc_onenand_small \
378 vct_premium_onenand \
379 vct_premium_onenand_small \
399 #########################################################################
400 ## MIPS Systems (little endian)
401 #########################################################################
420 #########################################################################
422 #########################################################################
424 LIST_x86="$(boards_by_arch x86)"
426 #########################################################################
428 #########################################################################
430 LIST_nios2="$(boards_by_arch nios2)"
432 #########################################################################
433 ## MicroBlaze Systems
434 #########################################################################
436 LIST_microblaze="$(boards_by_arch microblaze)"
438 #########################################################################
440 #########################################################################
442 LIST_m68k="$(boards_by_arch m68k)
444 EB+MCF-EV123_internal \
450 LIST_coldfire=${LIST_m68k}
452 #########################################################################
454 #########################################################################
456 LIST_avr32="$(boards_by_arch avr32)"
458 #########################################################################
460 #########################################################################
462 LIST_blackfin="$(boards_by_arch blackfin)"
464 #########################################################################
466 #########################################################################
468 LIST_sh2="$(boards_by_cpu sh2)"
469 LIST_sh3="$(boards_by_cpu sh3)"
470 LIST_sh4="$(boards_by_cpu sh4)"
472 LIST_sh="$(boards_by_arch sh)"
474 #########################################################################
476 #########################################################################
478 LIST_sparc="$(boards_by_arch sparc)"
480 #-----------------------------------------------------------------------
485 ${MAKE} distclean >/dev/null
486 ${MAKE} -s ${target}_config
488 ${MAKE} ${JOBS} all 2>&1 >${LOG_DIR}/$target.MAKELOG \
489 | tee ${LOG_DIR}/$target.ERR
491 # Check for 'make' errors
492 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
496 if [ -s ${LOG_DIR}/$target.ERR ] ; then
497 ERR_CNT=$((ERR_CNT + 1))
498 ERR_LIST="${ERR_LIST} $target"
500 rm ${LOG_DIR}/$target.ERR
503 TOTAL_CNT=$((TOTAL_CNT + 1))
505 ${CROSS_COMPILE}size ${BUILD_DIR}/u-boot \
506 | tee -a ${LOG_DIR}/$target.MAKELOG
510 # If a LIST_xxx var exists, use it. But avoid variable
511 # expansion in the eval when a board name contains certain
512 # characters that the shell interprets.
515 *) list=$(eval echo '${LIST_'$t'}') ;;
517 if [ -n "${list}" ] ; then
518 build_targets ${list}
525 #-----------------------------------------------------------------------
529 echo "--------------------- SUMMARY ----------------------------"
530 echo "Boards compiled: ${TOTAL_CNT}"
531 if [ ${ERR_CNT} -gt 0 ] ; then
532 echo "Boards with warnings or errors: ${ERR_CNT} (${ERR_LIST} )"
534 echo "----------------------------------------------------------"
539 #-----------------------------------------------------------------------
541 # Build target groups selected by options, plus any command line args
542 set -- ${SELECTED} "$@"
543 # run PowerPC by default
544 [ $# = 0 ] && set -- powerpc